/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the WhatsAppTemplateMessageMedia type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WhatsAppTemplateMessageMedia{}

// WhatsAppTemplateMessageMedia struct for WhatsAppTemplateMessageMedia
type WhatsAppTemplateMessageMedia struct {
	Id *string `json:"id,omitempty"`
	Link *string `json:"link,omitempty"`
	Filename *string `json:"filename,omitempty"`
}

// NewWhatsAppTemplateMessageMedia instantiates a new WhatsAppTemplateMessageMedia object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWhatsAppTemplateMessageMedia() *WhatsAppTemplateMessageMedia {
	this := WhatsAppTemplateMessageMedia{}
	return &this
}

// NewWhatsAppTemplateMessageMediaWithDefaults instantiates a new WhatsAppTemplateMessageMedia object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWhatsAppTemplateMessageMediaWithDefaults() *WhatsAppTemplateMessageMedia {
	this := WhatsAppTemplateMessageMedia{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *WhatsAppTemplateMessageMedia) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateMessageMedia) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *WhatsAppTemplateMessageMedia) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *WhatsAppTemplateMessageMedia) SetId(v string) {
	o.Id = &v
}

// GetLink returns the Link field value if set, zero value otherwise.
func (o *WhatsAppTemplateMessageMedia) GetLink() string {
	if o == nil || IsNil(o.Link) {
		var ret string
		return ret
	}
	return *o.Link
}

// GetLinkOk returns a tuple with the Link field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateMessageMedia) GetLinkOk() (*string, bool) {
	if o == nil || IsNil(o.Link) {
		return nil, false
	}
	return o.Link, true
}

// HasLink returns a boolean if a field has been set.
func (o *WhatsAppTemplateMessageMedia) HasLink() bool {
	if o != nil && !IsNil(o.Link) {
		return true
	}

	return false
}

// SetLink gets a reference to the given string and assigns it to the Link field.
func (o *WhatsAppTemplateMessageMedia) SetLink(v string) {
	o.Link = &v
}

// GetFilename returns the Filename field value if set, zero value otherwise.
func (o *WhatsAppTemplateMessageMedia) GetFilename() string {
	if o == nil || IsNil(o.Filename) {
		var ret string
		return ret
	}
	return *o.Filename
}

// GetFilenameOk returns a tuple with the Filename field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateMessageMedia) GetFilenameOk() (*string, bool) {
	if o == nil || IsNil(o.Filename) {
		return nil, false
	}
	return o.Filename, true
}

// HasFilename returns a boolean if a field has been set.
func (o *WhatsAppTemplateMessageMedia) HasFilename() bool {
	if o != nil && !IsNil(o.Filename) {
		return true
	}

	return false
}

// SetFilename gets a reference to the given string and assigns it to the Filename field.
func (o *WhatsAppTemplateMessageMedia) SetFilename(v string) {
	o.Filename = &v
}

func (o WhatsAppTemplateMessageMedia) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WhatsAppTemplateMessageMedia) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if !IsNil(o.Link) {
		toSerialize["link"] = o.Link
	}
	if !IsNil(o.Filename) {
		toSerialize["filename"] = o.Filename
	}
	return toSerialize, nil
}

type NullableWhatsAppTemplateMessageMedia struct {
	value *WhatsAppTemplateMessageMedia
	isSet bool
}

func (v NullableWhatsAppTemplateMessageMedia) Get() *WhatsAppTemplateMessageMedia {
	return v.value
}

func (v *NullableWhatsAppTemplateMessageMedia) Set(val *WhatsAppTemplateMessageMedia) {
	v.value = val
	v.isSet = true
}

func (v NullableWhatsAppTemplateMessageMedia) IsSet() bool {
	return v.isSet
}

func (v *NullableWhatsAppTemplateMessageMedia) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWhatsAppTemplateMessageMedia(val *WhatsAppTemplateMessageMedia) *NullableWhatsAppTemplateMessageMedia {
	return &NullableWhatsAppTemplateMessageMedia{value: val, isSet: true}
}

func (v NullableWhatsAppTemplateMessageMedia) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWhatsAppTemplateMessageMedia) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


